## sge-8.1.6.tar.gz

=== source/utilbin/Makefile ===
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__

###############################################################################
# Variable definitions for targets to build
###############################################################################
UTILBIN_DIR   = $(SDIR)/utilbin

UTILBIN_TARGETS = uidgid gethostname gethostbyname gethostbyaddr \
                 getservbyname filestat checkprog work \
                 signals loadcheck now \
                 adminrun checkuser languagetest \
                 testsuidroot infotext spooldefaults spooledit spoolinit read_raw echo_raw \
                 tst_pthread_signals fstype qping sgepasswd sge_share_mon \
                 valid_jvmlib $(AUTHUSER_ALL) $(LOADCHECK_ALL)

UTILBIN_SRC =  uidgid.c gethostname.c gethostbyname.c gethostbyaddr.c \
               getservbyname.c filestat.c signals.c now.c \
               checkuser.c adminrun.c range.c  \
               languagetest.c infotext.c \
               spooldefaults.c spooledit.c spoolinit.c read_raw.o echo_raw.o \
               tst_pthread_signals.c fstype.c qping.c authuser.c sge_share_mon.c \
               valid_jvmlib.c

UTILBIN_OBJS  = $(UTILBIN_SRC:.c=.o) 

UTILBIN_TARGET_OBJS = checkprog.o loadcheck.o testsuidroot.o work.o \
                      sge_passwd_main.o $(AUTHUSER_OBJ) $(LOADCHECK_OBJ) $(JUTI_OBJ)

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
utilbin:	$(UTILBIN_TARGETS)

utilbin_clean:
		$(RM) $(UTILBIN_TARGETS) $(UTILBIN_OBJS) $(UTILBIN_TARGET_OBJS)

utilbin_depend:
	$(DEPEND) -f$(UTILBIN_DIR)/utilbin_dependencies $(UTILBIN_DIR)/*.c

utilbin_messages:
	@echo Creating $@
	@for i in `ls $(UTILBIN_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(UTILBIN_DIR)/utilbin_dependencies

###############################################################################
# rules to build object codes and binaries
###############################################################################
uidgid:		uidgid.o version.o $(UTILIB) $(WINGRIDLIB_DEP) 
		$(CC) -o $@ $(LFLAGS) uidgid.o version.o -luti $(WINGRIDLIB) $(LIBS)

uidgid.o:	$(UTILBIN_DIR)/uidgid.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/uidgid.c

#---------------------------------------------------------------------
gethostname:	gethostname.o version.o $(UTILIB) $(WINGRIDLIB_DEP) $(COMMLIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) gethostname.o version.o  -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(DLLIB) $(LIBS)

gethostname.o:	$(UTILBIN_DIR)/gethostname.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/gethostname.c

#---------------------------------------------------------------------
gethostbyname:	gethostbyname.o version.o $(UTILIB) $(WINGRIDLIB_DEP) $(COMMLIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) gethostbyname.o version.o -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(DLLIB) $(LIBS)

gethostbyname.o:	$(UTILBIN_DIR)/gethostbyname.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/gethostbyname.c

#---------------------------------------------------------------------
qping:	qping.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(GDILIB) $(COMMLIB) $(COMMLISTSLIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(CULLLIB)
		$(CC) -o $@ $(LFLAGS) qping.o version.o -lgdi -lsgeobj -lsgeobjd -lcull -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(KRBLIB) $(DLLIB) $(SLIBS) $(LIBS)

qping.o:	$(UTILBIN_DIR)/qping.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/qping.c


#---------------------------------------------------------------------
gethostbyaddr:	gethostbyaddr.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) gethostbyaddr.o version.o -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(DLLIB) $(LIBS)

gethostbyaddr.o:	$(UTILBIN_DIR)/gethostbyaddr.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/gethostbyaddr.c

#---------------------------------------------------------------------
getservbyname:	getservbyname.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) 
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) getservbyname.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(DLLIB) $(LIBS)

getservbyname.o:	$(UTILBIN_DIR)/getservbyname.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/getservbyname.c

#---------------------------------------------------------------------
filestat:	filestat.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB)
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) filestat.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS)

filestat.o:	$(UTILBIN_DIR)/filestat.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/filestat.c

#---------------------------------------------------------------------
now:		now.o version.o
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) now.o version.o 

now.o:		$(UTILBIN_DIR)/now.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/now.c

#---------------------------------------------------------------------
read_raw:		read_raw.o version.o
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) read_raw.o version.o

read_raw.o:		$(UTILBIN_DIR)/read_raw.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/read_raw.c

#---------------------------------------------------------------------
echo_raw:		echo_raw.o version.o $(UTILIB) $(COMMLISTSLIB) 
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) echo_raw.o version.o -luti $(COMMLISTSLIB) $(LIBS)

echo_raw.o:		$(UTILBIN_DIR)/echo_raw.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/echo_raw.c

#---------------------------------------------------------------------
checkprog:	checkprog.o peopen_standalone.o pids_standalone.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) 
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) checkprog.o peopen_standalone.o pids_standalone.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS) $(DLLIB)

checkprog.o:	$(UTILBIN_DIR)/checkprog.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/checkprog.c

#---------------------------------------------------------------------
checkuser:     checkuser.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB)
		$(CC) $(CFLAGS) -o $@ $(LFLAGS) checkuser.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS)

checkuser.o:      $(UTILBIN_DIR)/checkuser.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/checkuser.c

#---------------------------------------------------------------------
adminrun:   adminrun.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) adminrun.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS)

adminrun.o: $(UTILBIN_DIR)/adminrun.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/adminrun.c

#---------------------------------------------------------------------
range:		range.o version.o 
		$(CC) -o $@ $(LFLAGS) range.o version.o 

range.o:	$(UTILBIN_DIR)/range.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/range.c

#---------------------------------------------------------------------
signals:	signals.o version.o 
		$(CC) -o $@ $(LFLAGS) signals.o version.o 

signals.o:	$(UTILBIN_DIR)/signals.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/signals.c

#---------------------------------------------------------------------
loadcheck: loadcheck.o version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(CULLLIB) binding_support.o
	$(CC) -o $@ $(LFLAGS) loadcheck.o version.o binding_support.o $(SGEOBJLIB) $(SGEOBJDLIB) $(CULLLIB) $(UTILIB) $(WINGRIDLIB) $(COMMLISTSLIB) $(LOADAVGLIBS) $(HWLOCLIB) $(LIBS)

loadcheck.o: $(UTILBIN_DIR)/loadcheck.c
	$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/loadcheck.c

LOADCHECK_WINLFLAGS = /SUBSYSTEM:CONSOLE $(WINLFLAGS)

loadcheck.exe: loadcheck.obj
	$(WINCC) loadcheck.obj /link /OUT:loadcheck.exe $(LOADCHECK_WINLFLAGS) $(WINLIBS)

loadcheck.obj: $(UTILBIN_DIR)/loadcheck.c
	$(WINCC) $(WINCFLAGS) /c $(UTILBIN_DIR)/loadcheck.c

#---------------------------------------------------------------------
languagetest:   languagetest.o version.o  $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) languagetest.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS)

languagetest.o: $(UTILBIN_DIR)/languagetest.c
		$(CC) $(CFLAGS) $(GCC_NODUPLWARN) -c $(UTILBIN_DIR)/languagetest.c
#---------------------------------------------------------------------
infotext:   infotext.o  version.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB) 
		$(CC) -o $@ $(LFLAGS) infotext.o version.o -luti $(WINGRIDLIB) $(COMMLISTSLIB) $(LIBS)

infotext.o: $(UTILBIN_DIR)/infotext.c
		$(CC) $(CFLAGS) $(GCC_NODUPLWARN) -c $(UTILBIN_DIR)/infotext.c

#---------------------------------------------------------------------
fstype:   fstype.o  version.o $(WINGRIDLIB_DEP) $(COMMLISTSLIB) $(UTILIB) 
		$(CC) -o $@ $(LFLAGS) fstype.o version.o $(WINGRIDLIB) $(FSTYPELIBS) -luti $(COMMLISTSLIB) $(LIBS)  

fstype.o: $(UTILBIN_DIR)/fstype.c
		$(CC) $(CFLAGS) $(MEMCFLAG) $(GCC_NODUPLWARN) -c $(UTILBIN_DIR)/fstype.c
#---------------------------------------------------------------------
spooldefaults:   spooldefaults.o  version.o sge_mt_init.o $(SPOOLING_DEPS) $(SPOOLCLIB) $(SPOOLLIB) $(SCHEDLIB) $(EVCLIB) $(GDILIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(COMMLIB) $(COMMLISTSLIB) $(CULLLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
		$(CC) -o $@ $(LFLAGS) spooldefaults.o version.o sge_mt_init.o -lspoolc $(SPOOLING_LIBS) -lsched -levc -lgdi -lsgeobj -lsgeobjd $(KRBLIB) -lcull -lcomm -lcommlists -luti $(SECLIB) $(WINGRIDLIB) $(DLLIB) $(SLIBS) $(LIBS)

spooldefaults.o: $(UTILBIN_DIR)/spooldefaults.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/spooldefaults.c

#---------------------------------------------------------------------
spoolinit:   spoolinit.o  version.o sge_mt_init.o $(SPOOLING_DEPS) $(SPOOLLIB) $(SCHEDLIB) $(EVCLIB) $(GDILIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(COMMLIB) $(COMMLISTSLIB) $(CULLLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
		$(CC) -o $@ $(LFLAGS) spoolinit.o version.o sge_mt_init.o $(SPOOLING_LIBS) -lsched -levc -lgdi -lsgeobj -lsgeobjd -lcull -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(KRBLIB) $(DLLIB) $(SLIBS) $(LIBS)

spoolinit.o: $(UTILBIN_DIR)/spoolinit.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/spoolinit.c

#---------------------------------------------------------------------
testsuidroot:   testsuidroot.o version.o $(WINGRIDLIB_DEP)  $(UTILIB) $(COMMLISTSLIB)
		$(CC) -o $@ $(LFLAGS) testsuidroot.o version.o -luti $(COMMLISTSLIB) $(WINGRIDLIB) $(LIBS)

testsuidroot.o: $(UTILBIN_DIR)/testsuidroot.c
		$(CC) $(CFLAGS) -c $(UTILBIN_DIR)/testsuidroot.c

#---------------------------------------------------------------------
work:	work.o version.o $(GDILIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(COMMLIB) $(COMMLISTSLIB) $(CULLLIB) $(WINGRIDLIB_DEP) $(UTILIB)

=== source/3rdparty/remote/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
REMOTE_DIR = ..

REMOTE_TARGETS = rlogin rsh rshd libsgeremote.a

REMOTE_CFLAGS = -UKERBEROS

SGE_DIR = ../../..
SGE_ARCH_DIR = $(SGE_DIR)/$(COMPILE_ARCH)

RSH_OBJS = rsh.o

RSHD_OBJS = rshd.o

RSHD_ADD_OBJS = \
            $(SGE_ARCH_DIR)/setosjobid.o        \
            $(SGE_ARCH_DIR)/config_file.o       \
            $(SGE_ARCH_DIR)/err_trace.o         \
            $(SGE_ARCH_DIR)/sge_uidgid.o        \
            $(SGE_ARCH_DIR)/execution_states.o  \
            $(SGE_ARCH_DIR)/qlogin_starter.o    \
            $(SGE_ARCH_DIR)/setjoblimit.o       \
            $(SGE_ARCH_DIR)/setrlimits.o        \
            $(SGE_ARCH_DIR)/sge_parse_num_par.o


RSHD_ADD_LIBS = -L$(SGE_ARCH_DIR) -luti2 -lsgeobj -lsgeobjd $(KRBLIB) -lcull -lcommlists -luti $(WINGRIDLIB_STATIC)

# The last dependency usually reduces to a directory, and Cygwin's make
# doesn't like it.  Assume wingrid is built already.
RSHD_LIB_DEPENDS = $(SGE_ARCH_DIR)/libuti$(LIBEXT) # $(SGE_ARCH_DIR)/$(WINGRIDLIB_DEP)

RLOGIN_OBJS = rlogin.o

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
all: $(REMOTE_TARGETS)

depend:
	@echo No dependencies for 3rd_party remote 

clean: 
	$(RM) $(REMOTE_TARGETS) $(RSH_OBJS) $(RSHD_OBJS) $(RLOGIN_OBJS) sgessh.o

messages:

###############################################################################
# rules to build object codes and binaries
###############################################################################
libsgeremote$(LIBEXT): $(RSHD_ADD_OBJS) $(RSHD_LIB_DEPENDS) sgessh.o
		$(AR) $(ARFLAGS) libsgeremote$(LIBEXT) $(RSHD_ADD_OBJS) sgessh.o

rlogin:   $(RLOGIN_OBJS)
		$(CC) -o $@ $(LFLAGS) $(RLOGIN_OBJS) $(LIBS)

rlogin.o: $(REMOTE_DIR)/rlogin.c
		$(CC) $(CFLAGS) $(REMOTE_CFLAGS) $(GCC_NODUPLWARN) -c $(REMOTE_DIR)/rlogin.c

rsh:   $(RSH_OBJS)
		$(CC) -o $@ $(LFLAGS) $(RSH_OBJS) $(LIBS)

rsh.o: $(REMOTE_DIR)/rsh.c
		$(CC) $(CFLAGS) $(REMOTE_CFLAGS) -c $(REMOTE_DIR)/rsh.c

rshd:   $(RSHD_OBJS) $(RSHD_ADD_OBJS) $(RSHD_LIB_DEPENDS) 
		$(CC) -o $@ $(LFLAGS) $(RSHD_OBJS) $(RSHD_ADD_OBJS) $(RSHD_ADD_LIBS) $(LIBS) 

rshd.o: $(REMOTE_DIR)/rshd.c $(RSHD_ADD_OBJS)
		$(CC) $(CFLAGS) $(REMOTE_CFLAGS) -I$(SGE_DIR)/daemons/common -I$(SGE_DIR)/common -I$(SGE_DIR)/libs/uti -I$(SGE_DIR)/daemons/shepherd -c $(REMOTE_DIR)/rshd.c

sgessh.o: $(REMOTE_DIR)/sgessh.c $(RSHD_ADD_OBJS)
		$(CC) $(CFLAGS) $(REMOTE_CFLAGS) -I$(SGE_DIR)/daemons/common -I$(SGE_DIR)/common -I$(SGE_DIR)/libs/uti -I$(SGE_DIR)/daemons/shepherd -c $(REMOTE_DIR)/sgessh.c

=== source/daemons/common/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__
DAEMONS_COMMON_DIR = $(SDIR)/daemons/common

DAEMONS_COMMON_SRC = admin_mail.c \
                    category.c \
                    err_trace.c \
                    lock.c \
                    mail.c \
                    qlogin_starter.c \
                    qmaster_heartbeat.c \
                    setosjobid.c \
                    shutdown.c \
                    startprog.c \
                    unparse_job_cull.c \
                    sge_processes_irix.c \
                    pdc.c \
                    procfs.c \
                    binding_support.c

DAEMONS_COMMON_TEST_OBJS = \
              test_category.o \
              test_heartbeat.o

DAEMONS_COMMON_TEST_PROGS = \
              test_category \
              test_heartbeat

DAEMONS_COMMON_OBJS = $(DAEMONS_COMMON_SRC:.c=.o)

DAEMONS_COMMON_PDC_TARGETS = pdc

DAEMONS_COMMON_PDC_OBJS = pdc_main.o \
               procfs_main.o
###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
daemons_common: $(DAEMONS_COMMON_OBJS) $(DAEMONS_COMMON_TEST_PROGS) $(DAEMONS_COMMON_PDC_TARGETS)

daemons_common_clean:
	$(RM) $(DAEMONS_COMMON_OBJS) $(DAEMONS_COMMON_TEST_OBJS) $(DAEMONS_COMMON_TEST_PROGS) $(DAEMONS_COMMON_PDC_TARGETS) $(DAEMONS_COMMON_PDC_OBJS)

daemons_common_depend:
	$(DEPEND) -f$(DAEMONS_COMMON_DIR)/common_dependencies $(DAEMONS_COMMON_DIR)/*.c

daemons_common_messages:
	@echo Creating $@
	@for i in `ls $(DAEMONS_COMMON_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ; \
	done

###############################################################################
# rules to build binaries
###############################################################################

test_category:	test_category.o category.o unparse_job_cull.o $(WINGRIDLIB_DEP) $(SCHEDLIB) $(SGEOBJLIB) $(SGEOBJDLIB) $(COMMLIB) $(COMMLISTSLIB) $(CULLLIB) $(UTILIB)  
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_category.o category.o unparse_job_cull.o $(SCHEDLIB) $(SGEOBJLIB) $(COMMLIB) $(COMMLISTSLIB) $(SGEOBJDLIB) $(CULLLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(SECLIB) $(SLIBS) $(LIBS)
test_heartbeat:	test_heartbeat.o qmaster_heartbeat.o $(WINGRIDLIB_DEP) $(UTILIB) $(COMMLISTSLIB)  
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_heartbeat.o qmaster_heartbeat.o $(UTILIB) $(WINGRIDLIB) $(COMMLISTSLIB) $(DLLIB) $(SLIBS) $(LIBS) 

pdc:  $(DAEMONS_COMMON_PDC_OBJS) $(SGEOBJLIB) $(CULLLIB) $(SGEOBJDLIB) $(COMMLIB)
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) $(DAEMONS_COMMON_PDC_OBJS) $(SCHEDLIB) $(SGEOBJLIB) $(COMMLIB) $(COMMLISTSLIB) $(SGEOBJDLIB) $(CULLLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(SECLIB) $(SLIBS) $(LIBS)
###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(DAEMONS_COMMON_DIR)/common_dependencies

###############################################################################
# rules to build object codes
###############################################################################
admin_mail.o : $(DAEMONS_COMMON_DIR)/admin_mail.c
		$(CC) $(CFLAGS) $(MEMCFLAG) -c $(DAEMONS_COMMON_DIR)/admin_mail.c

category.o:	$(DAEMONS_COMMON_DIR)/category.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/category.c

err_trace.o:	$(DAEMONS_COMMON_DIR)/err_trace.c
		$(CC) -I$(DAEMONS_COMMON_DIR) $(CFLAGS) $(MEMCFLAG) -c $(DAEMONS_COMMON_DIR)/err_trace.c

lock.o: 	$(DAEMONS_COMMON_DIR)/lock.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/lock.c

mail.o:		$(DAEMONS_COMMON_DIR)/mail.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/mail.c

qlogin_starter.o: $(DAEMONS_COMMON_DIR)/qlogin_starter.c
		$(CC) -I$(DAEMONS_COMMON_DIR) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/qlogin_starter.c

qmaster_heartbeat.o: $(DAEMONS_COMMON_DIR)/qmaster_heartbeat.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/qmaster_heartbeat.c

setosjobid.o: $(DAEMONS_COMMON_DIR)/setosjobid.c
		$(CC) -I$(DAEMONS_COMMON_DIR) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/setosjobid.c

shutdown.o   : $(DAEMONS_COMMON_DIR)/shutdown.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/shutdown.c

startprog.o   : $(DAEMONS_COMMON_DIR)/startprog.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/startprog.c

unparse_job_cull.o: 	$(DAEMONS_COMMON_DIR)/unparse_job_cull.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/unparse_job_cull.c

sge_processes_irix.o: 	$(DAEMONS_COMMON_DIR)/sge_processes_irix.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/sge_processes_irix.c

pdc_main.o: 	$(DAEMONS_COMMON_DIR)/pdc.c
		$(CC) $(CFLAGS) -DMONITOR_PDC -DPDC_STANDALONE $(MEMCFLAG) $(GCCC_NOERR_FLAGS) -c $(DAEMONS_COMMON_DIR)/pdc.c -o pdc_main.o

procfs_main.o: 	$(DAEMONS_COMMON_DIR)/procfs.c
		$(CC) $(CFLAGS) -DMONITOR_PDC -DPDC_STANDALONE $(MEMCFLAG) -c $(DAEMONS_COMMON_DIR)/procfs.c -o procfs_main.o

pdc.o: 	$(DAEMONS_COMMON_DIR)/pdc.c
		$(CC) $(CFLAGS) $(MEMCFLAG) $(GCCC_NOERR_FLAGS) -c $(DAEMONS_COMMON_DIR)/pdc.c

procfs.o: 	$(DAEMONS_COMMON_DIR)/procfs.c
		$(CC) $(CFLAGS) $(MEMCFLAG) -c $(DAEMONS_COMMON_DIR)/procfs.c

binding_support.o: 	$(DAEMONS_COMMON_DIR)/binding_support.c
		$(CC) $(CFLAGS) $(MEMCFLAG) -c $(DAEMONS_COMMON_DIR)/binding_support.c

test_category.o : $(DAEMONS_COMMON_DIR)/test_category.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/test_category.c

test_heartbeat.o : $(DAEMONS_COMMON_DIR)/test_heartbeat.c
		$(CC) $(CFLAGS) -c $(DAEMONS_COMMON_DIR)/test_heartbeat.c

=== source/daemons/qmaster/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__

QMASTER_DIR = $(SDIR)/daemons/qmaster

QMASTER_TARGETS = sge_qmaster

QMASTER_SRC = sge_qmaster_threads.c \
              sge_thread_listener.c \
              sge_thread_worker.c \
              sge_thread_event_master.c \
              sge_thread_timer.c \
              sge_thread_test.c \
              sge_thread_scheduler.c \
              sge_thread_signaler.c \
              sge_thread_jvm.c \
              sge_thread_main.c \
              sge_sched_prepare_data.c \
              sge_sched_job_category.c \
              sge_sched_process_events.c \
              sge_sched_thread.c \
              sge_sched_order.c \
              sge_c_gdi.c \
              sge_follow.c \
              sge_give_jobs.c \
              reschedule.c \
              job_exit.c \
              sge_host_qmaster.c \
              sge_job_qmaster.c \
              sge_job_verify.c \
              sge_manop_qmaster.c \
              sge_pe_qmaster.c \
              sge_ckpt_qmaster.c \
              sge_cqueue_qmaster.c \
              sge_qinstance_qmaster.c \
              sge_qmod_qmaster.c \
              sge_rusage.c \
              sge_sharetree_qmaster.c \
              sge_calendar_qmaster.c \
              sge_userprj_qmaster.c \
              sge_cuser_qmaster.c \
              sge_hgroup_qmaster.c \
              sge_userset_qmaster.c \
              sge_centry_qmaster.c \
              configuration_qmaster.c \
              job_report_qmaster.c \
              qmaster_to_execd.c \
              sched_conf_qmaster.c \
              setup_qmaster.c \
              sge_subordinate_qmaster.c \
              sge_qmaster_timed_event.c \
              sge_qmaster_heartbeat.c \
              sge_utility_qmaster.c \
              sge_persistence_qmaster.c \
              sge_qmaster_process_message.c \
              sge_c_report.c \
              sge_reporting_qmaster.c \
              sge_resource_quota_qmaster.c \
              sge_task_depend.c \
              sge_advance_reservation_qmaster.c \
              sge_job_enforce_limit.c
             
QMASTER_ADD_SRC = usage.c sge_options.c \
              startprog.c shutdown.c \
              admin_mail.c \
              category.c \
              config_file.c \
              execution_states.c \
              lock.c \
              mail.c \
              qmaster_heartbeat.c \
              sge_dirent.c \
              sig_handlers.c \
              unparse_job_cull.c \
              sge_mt_init.c

QMASTER_OBJS  = $(QMASTER_SRC:.c=.o)

QMASTER_ADD_OBJS = $(QMASTER_ADD_SRC:.c=.o)

QMASTER_ADD_LIBS = $(SPOOLING_LIBS) -lsched $(EVMLIB) -levc $(MIRLIB) -lgdi -lsgeobj -lsgeobjd -lcull -lcomm -lcommlists -luti $(WINGRIDLIB) $(SECLIB) $(KRBLIB) $(DLLIB)

QMASTER_LIB_DEPENDS = $(SCHEDLIB) $(EVMLIB) $(EVCLIB) $(MIRLIB) \
                      $(GDILIB) $(SGEOBJLIB) $(SPOOLING_DEPS) $(SGEOBJDLIB) \
                      $(KRBLIBS) $(CULLLIB) $(COMMLIB) $(COMMLISTSLIB) \
                      $(WINGRIDLIB_DEP) $(UTILIB) $(TPLIB)

QMASTER_TEST_OBJS = \
              test_sge_qmaster_timed_event.o \
              test_sge_calendar.o 

QMASTER_TEST_PROGS = \
              test_sge_qmaster_timed_event \
              test_sge_calendar

QMASTER_TEST_ADD_LIBS = $(QMASTER_ADD_LIBS)

QMASTER_TEST_LIB_DEPENDS = $(SGEOBJLIB) $(SGEOBJDLIB) $(CULLLIB) $(COMMLIB) $(COMMLISTSLIB) $(UTILIB)  

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
.PHONY: qmaster

qmaster: $(QMASTER_TARGETS) $(QMASTER_TEST_PROGS)
	@true

qmaster_clean:
	$(RM) $(QMASTER_TARGETS) sge_qmaster_main.o $(QMASTER_OBJS) $(QMASTER_TEST_OBJS) $(QMASTER_TEST_PROGS)

qmaster_depend:
	$(DEPEND) -f$(QMASTER_DIR)/qmaster_dependencies $(QMASTER_DIR)/*.c

qmaster_messages:
	@echo Creating $@
	@for i in `ls $(QMASTER_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ; \
	done

###############################################################################
# rules to build binaries
###############################################################################
sge_qmaster:	sge_qmaster_main.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_LIB_DEPENDS)
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) sge_qmaster_main.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_ADD_LIBS) $(SLIBS) $(LIBS) \
    && ../scripts/nonreentrant.sh -a `../dist/util/arch` -w $@

test_sge_qmaster_timed_event:	test_sge_qmaster_timed_event.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_LIB_DEPENDS)
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_sge_qmaster_timed_event.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_ADD_LIBS) $(SLIBS) $(LIBS) 

test_sge_calendar:	test_sge_calendar.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_LIB_DEPENDS)
		$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_sge_calendar.o $(QMASTER_OBJS) $(QMASTER_ADD_OBJS) $(QMASTER_ADD_LIBS) $(SLIBS) $(LIBS) 

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(QMASTER_DIR)/qmaster_dependencies

###############################################################################
# rules to build object codes
###############################################################################
sge_qmaster_main.o: 	$(QMASTER_DIR)/sge_qmaster_main.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_qmaster_main.c

sge_qmaster_threads.o: 	$(QMASTER_DIR)/sge_qmaster_threads.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_qmaster_threads.c

sge_thread_listener.o: 	$(QMASTER_DIR)/sge_thread_listener.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_listener.c

sge_thread_worker.o: 	$(QMASTER_DIR)/sge_thread_worker.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_worker.c

sge_thread_event_master.o: 	$(QMASTER_DIR)/sge_thread_event_master.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_event_master.c

sge_thread_timer.o: 	$(QMASTER_DIR)/sge_thread_timer.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_timer.c

sge_thread_test.o: 	$(QMASTER_DIR)/sge_thread_test.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_test.c

sge_thread_scheduler.o: 	$(QMASTER_DIR)/sge_thread_scheduler.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_scheduler.c

sge_thread_signaler.o: 	$(QMASTER_DIR)/sge_thread_signaler.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_signaler.c

sge_thread_jvm.o: 	$(QMASTER_DIR)/sge_thread_jvm.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_jvm.c

sge_thread_main.o: 	$(QMASTER_DIR)/sge_thread_main.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_thread_main.c

sge_qmod_qmaster.o:	$(QMASTER_DIR)/sge_qmod_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_qmod_qmaster.c

sge_userset_qmaster.o:	$(QMASTER_DIR)/sge_userset_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_userset_qmaster.c

sge_c_gdi.o:	$(QMASTER_DIR)/sge_c_gdi.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_c_gdi.c

sge_job_qmaster.o:	$(QMASTER_DIR)/sge_job_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_job_qmaster.c

sge_job_verify.o:	$(QMASTER_DIR)/sge_job_verify.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_job_verify.c

sge_cqueue_qmaster.o:	$(QMASTER_DIR)/sge_cqueue_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_cqueue_qmaster.c

sge_qinstance_qmaster.o:	$(QMASTER_DIR)/sge_qinstance_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_qinstance_qmaster.c

sge_manop_qmaster.o:	$(QMASTER_DIR)/sge_manop_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_manop_qmaster.c

sge_follow.o:   $(QMASTER_DIR)/sge_follow.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_follow.c

sge_sched_process_events.o: $(QMASTER_DIR)/sge_sched_process_events.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sched_process_events.c

sge_sched_thread.o: $(QMASTER_DIR)/sge_sched_thread.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sched_thread.c

sge_sched_order.o: $(QMASTER_DIR)/sge_sched_order.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sched_order.c

sge_sched_prepare_data.o: $(QMASTER_DIR)/sge_sched_prepare_data.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sched_prepare_data.c

sge_sched_job_category.o: $(QMASTER_DIR)/sge_sched_job_category.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sched_job_category.c

sge_give_jobs.o: $(QMASTER_DIR)/sge_give_jobs.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/sge_give_jobs.c   

reschedule.o: $(QMASTER_DIR)/reschedule.c
		$(CC) -o $@ $(CFLAGS) -c $(QMASTER_DIR)/reschedule.c   

sge_host_qmaster.o: $(QMASTER_DIR)/sge_host_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_host_qmaster.c

sge_pe_qmaster.o: $(QMASTER_DIR)/sge_pe_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_pe_qmaster.c

sge_ckpt_qmaster.o: $(QMASTER_DIR)/sge_ckpt_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_ckpt_qmaster.c

sge_rusage.o:	$(QMASTER_DIR)/sge_rusage.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_rusage.c

sge_userprj_qmaster.o:	$(QMASTER_DIR)/sge_userprj_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_userprj_qmaster.c

sge_cuser_qmaster.o:	$(QMASTER_DIR)/sge_cuser_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_cuser_qmaster.c

sge_hgroup_qmaster.o:	$(QMASTER_DIR)/sge_hgroup_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_hgroup_qmaster.c

sge_calendar_qmaster.o: $(QMASTER_DIR)/sge_calendar_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_calendar_qmaster.c

sge_sharetree_qmaster.o: $(QMASTER_DIR)/sge_sharetree_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_sharetree_qmaster.c

sge_centry_qmaster.o: $(QMASTER_DIR)/sge_centry_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_centry_qmaster.c

configuration_qmaster.o:  $(QMASTER_DIR)/configuration_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/configuration_qmaster.c

job_exit.o   : $(QMASTER_DIR)/job_exit.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/job_exit.c

job_report_qmaster.o   : $(QMASTER_DIR)/job_report_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/job_report_qmaster.c

sched_conf_qmaster.o   : $(QMASTER_DIR)/sched_conf_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sched_conf_qmaster.c

setup_qmaster.o   : $(QMASTER_DIR)/setup_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/setup_qmaster.c

sge_subordinate_qmaster.o   : $(QMASTER_DIR)/sge_subordinate_qmaster.c
		$(CC) $(CFLAGS) -c $(QMASTER_DIR)/sge_subordinate_qmaster.c

sge_qmaster_timed_event.o   : $(QMASTER_DIR)/sge_qmaster_timed_event.c

=== source/daemons/shepherd/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__
SHEPHERD_DIR = $(SDIR)/daemons/shepherd

SHEPHERD_TARGETS = sge_shepherd

SHEPHERD_SRC = shepherd.c \
           builtin_starter.c \
           setrlimits.c \
           signal_queue.c \
           sge_shepconf.c \
           setjoblimit.c \
           sge_pset.c \
           sge_fileio.c \
           sge_shepherd_ijs.c \
           shepherd_binding.c 

SHEPHERD_ADD_SRC = \
           config_file.c \
           err_trace.c \
           execution_states.c \
           qlogin_starter.c \
           setosjobid.c \
           sge_parse_num_par.c \
           pdc.c \
           procfs.c \
           sge_mt_init.c \
           sge_processes_irix.c \
           sge_spool.c \
           binding_support.c

SHEPHERD_OBJS = $(SHEPHERD_SRC:.c=.o) sge_ijs_comm.o sge_ijs_threads.o

SHEPHERD_ADD_OBJS = $(SHEPHERD_ADD_SRC:.c=.o) 

SHEPHERD_ADD_LIBS = -lgdi -lsgeobj -lsgeobjd $(KRBLIB) -lcull -lcomm_static -lcommlists -luti -luti2 $(HWLOCLIB) $(WINGRIDLIB_STATIC) $(DLLIB)

SHEPHERD_LIB_DEPENDS = $(GDILIB) $(SGEOBJDLIB) $(SGEOBJLIB) $(KRBLIBS) $(CULLLIB) $(COMMLIB) $(COMMLISTSLIB) $(COMMLIB_STATIC) $(UTILIB) $(UTI2LIB) $(WINGRIDLIB_DEP)  

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
shepherd: $(SHEPHERD_TARGETS)
	
shepherd_clean:
		$(RM) $(SHEPHERD_TARGETS) $(SHEPHERD_OBJS)

shepherd_depend:
		$(DEPEND) -f$(SHEPHERD_DIR)/shepherd_dependencies $(SHEPHERD_DIR)/*.c

shepherd_messages:
	@echo Creating $@
	@for i in `ls $(SHEPHERD_DIR)/*.c`; do \
	   $(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build binaries
###############################################################################
sge_shepherd:	$(SHEPHERD_OBJS) $(SHEPHERD_ADD_OBJS) $(SHEPHERD_LIB_DEPENDS)
		$(LD_WRAPPER) $(CC) -I$(SHEPHERD_DIR) $(CFLAGS) $(LFLAGS) -o $@ $(SHEPHERD_OBJS) $(SHEPHERD_ADD_OBJS) $(SHEPHERD_ADD_LIBS) $(SECLIBS_STATIC) $(SLIBS) $(LIBS)

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(SHEPHERD_DIR)/shepherd_dependencies

###############################################################################
# rules to build object codes
###############################################################################
shepherd.o:	$(SHEPHERD_DIR)/shepherd.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) $(MEMCFLAG) -c $(SHEPHERD_DIR)/shepherd.c

sge_starter.o:	$(SHEPHERD_DIR)/sge_starter.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/sge_starter.c

builtin_starter.o:	$(SHEPHERD_DIR)/builtin_starter.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/builtin_starter.c

signal_queue.o:	$(SHEPHERD_DIR)/signal_queue.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/signal_queue.c

sge_shepconf.o:	$(SHEPHERD_DIR)/sge_shepconf.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/sge_shepconf.c

setrlimits.o:	$(SHEPHERD_DIR)/setrlimits.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/setrlimits.c

setjoblimit.o: $(SHEPHERD_DIR)/setjoblimit.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/setjoblimit.c

sge_pset.o: $(SHEPHERD_DIR)/sge_pset.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/sge_pset.c

sge_fileio.o: $(SHEPHERD_DIR)/sge_fileio.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/sge_fileio.c

sge_shepherd_ijs.o: $(SHEPHERD_DIR)/sge_shepherd_ijs.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/sge_shepherd_ijs.c

shepherd_binding.o: $(SHEPHERD_DIR)/shepherd_binding.c
		$(CC) -I$(SHEPHERD_DIR) $(CFLAGS) -c $(SHEPHERD_DIR)/shepherd_binding.c

=== source/libs/comm/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__

##########################################################################
SHELL  = /bin/sh
RM     = rm -f 
DEPEND = $(SOURCE)/3rdparty/sge_depend/$(COMPILE_ARCH)/sge_depend -l -S -Y $(DEPEND_FLAGS)
##########################################################################

###############################################################################
include $(SDIR)/libs/comm/lists/Makefile
include $(SDIR)/libs/comm/examples/Makefile
###############################################################################

COMMLIB = libcomm$(LIBEXT)
COMMLIB_STATIC = libcomm_static.a
COMMLIB_DIR = $(SDIR)/libs/comm
COMMLIB_SRC = \
         cl_tcp_framework.c \
         cl_communication.c \
         cl_xml_parsing.c \
         cl_connection_list.c \
         cl_app_message_queue.c \
         cl_message_list.c \
         cl_fd_list.c \
         cl_host_list.c \
         cl_host_alias_list.c \
         cl_endpoint_list.c \
         cl_handle_list.c \
         cl_application_error_list.c \
         cl_commlib.c

# We need to build a version of the commlib that uses statically linked
# libssl.a and libcrypto.a, because the sge_shepherd can't use the
# compiled in runpath ($ORIGIN/...) and we don't want to set the
# LD_LIBRARY_PATH to our libs directory for the shepherd.
# The shepherd can't use the runpath, because for security reasons, the
# runpath is always empty for binaries that are started with different
# uid and euid, and the shepherd must be started with uid=root and 
# euid=sge admin user.

COMMLIB_SSL_DYNAMIC_OBJ  = cl_ssl_framework.o
COMMLIB_SSL_STATIC_OBJ  = cl_ssl_framework_static.o

COMMLIB_OBJS = $(COMMLIB_SRC:.c=.o) $(COMMLIB_SSL_DYNAMIC_OBJ)
COMMLIB_STATIC_OBJS = $(COMMLIB_SRC:.c=.o) $(COMMLIB_SSL_STATIC_OBJ)

COMMLIB_TEST_SRC = \
         test_cl_tcp_framework.c \
         test_cl_commlib.c \
         test_server_connection.c \
         test_cl_commlib_client.c \
         test_cl_hostname_list.c  \
         test_cl_hostalias_list.c \
         test_cl_endpoint_list.c \
         test_cl_com_parameter_list.c \
         test_multithread_io.c  \
         test_virtual_qmaster.c \
         test_virtual_event_client.c \
         test_virtual_gdi_client.c \
         test_debug_client.c \
         test_status_info.c \
         test_issues.c \
         test_general.c \
         test_commlib_issue.c \
         test_cl_issue_2747_server.c \
         test_cl_issue_2747_client.c \
         test_thread_throughput.c

COMMLIB_TEST_OBJS = $(COMMLIB_TEST_SRC:.c=.o)

###############################################################################
COMMLIBS = $(COMMLIB) $(COMMLISTSLIB) $(COMMLIB_STATIC)

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
comm_all: commlib commlists_all commexamples_all test_cl_commlib test_cl_commlib_client \
     test_cl_hostname_list test_cl_hostalias_list test_multithread_io test_status_info \
     test_server_connection test_cl_endpoint_list test_cl_com_parameter_list test_virtual_qmaster \
     test_virtual_event_client test_virtual_gdi_client test_debug_client test_general \
     test_commlib_issue test_cl_issue_2747_server test_cl_issue_2747_client test_issues test_thread_throughput

depend: commlib_depend commlistslib_depend

messages: commlib_messages commlistslib_messages

clean: commlib_clean commexamples_clean commlistslib_clean

commlib: $(COMMLIBS)

commlib_clean: commlistslib_clean
		$(RM) $(COMMLIB_OBJS) $(COMMLIB_TEST_OBJS) $(COMMLIB_SSL_STATIC_OBJ) libcomm.a \
      libcomm_static.a libcomm$(SHAREDEXT) \
      test_cl_tcp_framework test_cl_commlib_client test_cl_commlib test_cl_hostname_list \
      test_cl_hostalias_list test_multithread_io test_status_info test_server_connection \
      test_cl_endpoint_list test_cl_com_parameter_list test_virtual_qmaster test_virtual_event_client \
      test_virtual_gdi_client test_debug_client test_general test_commlib_issue test_cl_issue_2747_server \
      test_cl_issue_2747_client test_issues test_thread_throughput

commlib_depend: commlistslib_depend
		$(DEPEND) -f$(COMMLIB_DIR)/commlib_dependencies $(COMMLIB_DIR)/*.c

commlib_messages: commlistslib_messages
	@echo Creating $@
	@for i in `ls $(COMMLIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build library
###############################################################################
libcomm.a:	$(COMMLIB_OBJS)
	$(AR) $(ARFLAGS) libcomm.a $(COMMLIB_OBJS)
	$(RANLIB) libcomm.a

libcomm$(SHAREDEXT): $(COMMLIB_OBJS) $(SGEOBJLIB) $(SGEOBJDLIB) $(COMMLISTSLIB) $(CULLLIB) $(UTILIB)
	$(SHAREDLD) $(SHARED_LFLAGS) -o libcomm$(SHAREDEXT) $(COMMLIB_OBJS) -luti $(DLLIB) $(LIBS)

libcomm_static.a:	$(COMMLIB_STATIC_OBJS)
	$(AR) $(ARFLAGS) libcomm_static.a $(COMMLIB_STATIC_OBJS)
	$(RANLIB) libcomm_static.a

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(COMMLIB_DIR)/commlib_dependencies

###############################################################################
# rules to build object codes
###############################################################################
cl_tcp_framework.o: $(COMMLIB_DIR)/cl_tcp_framework.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_tcp_framework.c
# unset prototype warning (with NOERR_PROTO) for ssl_framework file because ssl has no strict prototypes
cl_ssl_framework.o: $(COMMLIB_DIR)/cl_ssl_framework.c 
		$(CC) $(CFLAGS) $(NOERR_PROTO) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_ssl_framework.c
cl_ssl_framework_static.o: $(COMMLIB_DIR)/cl_ssl_framework.c 
		$(CC) $(CFLAGS) $(NOERR_PROTO) $(SHARED_CFLAGS) -ULOAD_OPENSSL -c $(COMMLIB_DIR)/cl_ssl_framework.c -o $(COMMLIB_SSL_STATIC_OBJ)
cl_communication.o: $(COMMLIB_DIR)/cl_communication.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_communication.c
cl_xml_parsing.o: $(COMMLIB_DIR)/cl_xml_parsing.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_xml_parsing.c
cl_connection_list.o: $(COMMLIB_DIR)/cl_connection_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_connection_list.c
cl_app_message_queue.o: $(COMMLIB_DIR)/cl_app_message_queue.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_app_message_queue.c
cl_message_list.o: $(COMMLIB_DIR)/cl_message_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_message_list.c
cl_fd_list.o: $(COMMLIB_DIR)/cl_fd_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_fd_list.c
cl_host_list.o: $(COMMLIB_DIR)/cl_host_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_host_list.c
cl_endpoint_list.o: $(COMMLIB_DIR)/cl_endpoint_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_endpoint_list.c
cl_host_alias_list.o: $(COMMLIB_DIR)/cl_host_alias_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_host_alias_list.c
cl_handle_list.o: $(COMMLIB_DIR)/cl_handle_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_handle_list.c
cl_application_error_list.o: $(COMMLIB_DIR)/cl_application_error_list.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_application_error_list.c
cl_commlib.o: $(COMMLIB_DIR)/cl_commlib.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(COMMLIB_DIR)/cl_commlib.c

#---------------------------------------------------------------------
# test programs
test_cl_tcp_framework:	test_cl_tcp_framework.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB)
	$(CC) -o test_cl_tcp_framework $(LFLAGS) test_cl_tcp_framework.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_commlib: test_cl_commlib.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_cl_commlib $(LFLAGS) test_cl_commlib.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_server_connection: test_server_connection.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_server_connection $(LFLAGS) test_server_connection.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_commlib_client: test_cl_commlib_client.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB)  
	$(CC) -o test_cl_commlib_client $(LFLAGS) test_cl_commlib_client.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_hostname_list: test_cl_hostname_list.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_cl_hostname_list $(LFLAGS) test_cl_hostname_list.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_endpoint_list: test_cl_endpoint_list.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB)  
	$(CC) -o test_cl_endpoint_list $(LFLAGS) test_cl_endpoint_list.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_com_parameter_list: test_cl_com_parameter_list.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_cl_com_parameter_list $(LFLAGS) test_cl_com_parameter_list.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_cl_hostalias_list: test_cl_hostalias_list.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_cl_hostalias_list $(LFLAGS) test_cl_hostalias_list.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_multithread_io: test_multithread_io.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB)  
	$(CC) -o test_multithread_io $(LFLAGS) test_multithread_io.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_virtual_qmaster: test_virtual_qmaster.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_virtual_qmaster $(LFLAGS) test_virtual_qmaster.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_virtual_event_client: test_virtual_event_client.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB) 
	$(CC) -o test_virtual_event_client $(LFLAGS) test_virtual_event_client.o $(COMMLIB) $(SECLIB) $(COMMLISTSLIB) $(UTILIB) $(WINGRIDLIB) $(DLLIB) $(LIBS)

test_virtual_gdi_client: test_virtual_gdi_client.o $(COMMLIB) $(COMMLISTSLIB) $(WINGRIDLIB_DEP) $(UTILIB)

=== source/libs/gdi/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__
GDILIB_DIR = $(SDIR)/libs/gdi

GDILIB = libgdi$(LIBEXT)

GDILIB_SRC = pack_job_delivery.c \
             sge_gdi_ctx.c \
             sge_gdi2.c \
             sge_gdi_packet.c \
             sge_gdi_packet_internal.c \
             sge_gdi_packet_pb_cull.c \
             sge_qexec.c \
             qm_name.c \
             sge_security.c \
             sge_qtcsh.c \
             version.c

GDILIB_OBJS = $(GDILIB_SRC:.c=.o)

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
gdilib: $(GDILIB)

gdilib_clean:
		$(RM) $(GDILIB_OBJS) libgdi.a libgdi$(SHAREDEXT)

gdilib_depend:
		$(DEPEND) -f$(GDILIB_DIR)/gdi_dependencies $(GDILIB_DIR)/*.c

gdilib_messages:
	@echo Creating $@
	@for i in `ls $(GDILIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build library
###############################################################################
libgdi.a:	$(GDILIB_OBJS) 
	$(AR) $(ARFLAGS) libgdi.a $(GDILIB_OBJS)
	$(RANLIB) libgdi.a

libgdi$(SHAREDEXT): $(GDILIB_OBJS) $(SGEOBJDLIB) $(COMMLIB) $(COMMLISTSLIB) $(CULLLIB) $(UTILIB) 
	$(SHAREDLD) $(SHARED_LFLAGS) -o libgdi$(SHAREDEXT) $(GDILIB_OBJS) -lsgeobjd -lcomm -lcommlists -lcull -luti $(LIBS) -lc

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(GDILIB_DIR)/gdi_dependencies

###############################################################################
# rules to build object codes
###############################################################################
version.o:	$(GDILIB_DIR)/version.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/version.c

sge_qexec.o:	$(GDILIB_DIR)/sge_qexec.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_qexec.c

sge_gdi2.o:	$(GDILIB_DIR)/sge_gdi2.c
		$(CC) -o $@ $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_gdi2.c

sge_gdi_packet.o:	$(GDILIB_DIR)/sge_gdi_packet.c
		$(CC) -o $@ $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_gdi_packet.c

sge_gdi_packet_internal.o:	$(GDILIB_DIR)/sge_gdi_packet_internal.c
		$(CC) -o $@ $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_gdi_packet_internal.c

sge_gdi_packet_pb_cull.o:	$(GDILIB_DIR)/sge_gdi_packet_pb_cull.c
		$(CC) -o $@ $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_gdi_packet_pb_cull.c

sge_gdi_ctx.o:	$(GDILIB_DIR)/sge_gdi_ctx.c
		$(CC) -o $@ $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_gdi_ctx.c

pack_job_delivery.o:	$(GDILIB_DIR)/pack_job_delivery.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/pack_job_delivery.c

qm_name.o: 	$(GDILIB_DIR)/qm_name.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/qm_name.c

sge_security.o: $(GDILIB_DIR)/sge_security.c 
		$(CC) $(CFLAGS) $(NOERR_CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_security.c

sge_qtcsh.o: $(GDILIB_DIR)/sge_qtcsh.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(GDILIB_DIR)/sge_qtcsh.c

#---------------------------------------------------------------------
# test programs

=== source/libs/ijs/Makefile ===
#Portions of this code are Copyright 2011 Univa Inc.
IJSLIB_DIR = $(SDIR)/libs/ijs

IJSLIB_SRC =   \
               sge_ijs_lib.c

IJSLIB_OBJS = $(IJSLIB_SRC:.c=.o)

IJSLIB =libijs.a

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################

ijslib: $(IJSLIB)

ijslib_clean:
		$(RM) $(IJSLIB_OBJS) libijs.a

ijslib_depend:
		$(DEPEND) -f$(IJSLIB_DIR)/ijs_dependencies $(IJSLIB_DIR)/*.c

ijslib_messages:
	@echo Creating $@
	@for i in `ls $(IJSLIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build library
###############################################################################
libijs.a:	$(IJSLIB_OBJS) 
	$(AR) $(ARFLAGS) libijs.a $(IJSLIB_OBJS)
	$(RANLIB) libijs.a

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(IJSLIB_DIR)/ijs_dependencies

###############################################################################
# rules to build object codes
###############################################################################
sge_ijs_lib.o:	$(IJSLIB_DIR)/sge_ijs_lib.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(IJSLIB_DIR)/sge_ijs_lib.c

#---------------------------------------------------------------------
# test programs

=== source/libs/japi/Makefile ===
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__

# Variable definitions for targets to build

JAPILIB_DIR   = $(SDIR)/libs/japi
CLASSES_DIR   = $(SDIR)/libs/jdrmaa

JAPILIB_10    = japi.o
JAPILIB_OBJS  = $(JAPILIB_10)

DRMAALIB         = libdrmaa$(SHAREDEXT)
DRMAALIB_V       = libdrmaa$(SHAREDEXT).1.0
DRMAALIB_10_NJ  = drmaa.o
DRMAALIB_10_ALL = $(DRMAALIB_10_NJ) com_sun_grid_drmaa_SessionImpl.o

# This computed macro is here to allow libdrmaa to be built with or without
# JNI files
DRMAALIB_10_OBJS = $(DRMAALIB_10_$(JNI_TARGET))
DRMAALIB_OBJS    = $(DRMAALIB_10_OBJS)
DRMAA_OBJS       = $(EVCLIB_OBJS) $(GDILIB_OBJS) \
                   $(SGEOBJLIB_OBJS) $(SGEOBJDLIB_OBJS) \
                   $(CULLLIB_OBJS) $(COMMLIB_OBJS) \
                   $(COMMLISTSLIB_OBJS) $(UTILIB_DRMAA_OBJS) 

JAPI_ADD_SRC = parse_job_cull.c parse_qsub.c read_defaults.c sge_options.c
JAPI_ADD_OBJS = $(JAPI_ADD_SRC:.c=.o)
JAPI_DEPEND_OBJS = $(JAPI_ADD_OBJS)

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
drmaa_all: drmaalib japilib drmaa_extras

drmaa_clean: japi_clean drmaa_extras_clean
	$(RM) $(DRMAALIB_OBJS) libdrmaa.a $(DRMAALIB) $(DRMAALIB_V) libdrmaa$(JAVA_SHAREDEXT)

drmaa_extras_clean: drmaa_howto_clean
	$(RM) test_drmaa test_drmaa.o example example.o test_drmaa_perf \
         test_drmaa_perf.o test_drmaa_sync \
         test_drmaa_sync.o test_drmaa_no_bin test_drmaa_no_bin.o \
         test_drmaa_issue1768 test_drmaa_issue1768.o \
         test_drmaa_issue1832 test_drmaa_issue1832.o \
         test_drmaa_issue1892 test_drmaa_issue1892.o \
         test_drmaa.1.0 test_drmaa.o \
         compile compile.o

japilib: $(JAPILIB)
drmaalib: $(DRMAALIB)

drmaa_extras: drmaa_howto_all test_drmaa example test_drmaa_perf test_drmaa_sync \
              test_drmaa_no_bin test_drmaa_issue1768 test_drmaa_issue1832 \
              test_drmaa_issue1892 compile \

japi_clean:
	$(RM) $(JAPILIB_OBJS) libjapi.*.*$(LIBEXT) libjapi$(JAVA_SHAREDEXT)

drmaa_depend:
	$(DEPEND) -f$(JAPILIB_DIR)/japi_dependencies $(JAPILIB_DIR)/*.c

drmaa_messages:
	@echo Creating $@
	@for i in `ls $(JAPILIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build library
###############################################################################
libdrmaa$(SHAREDEXT).1.0:  $(JAPILIB_10) $(JAPI_DEPEND_OBJS) $(DRMAALIB_OBJS) $(DRMAA_OBJS) $(WINGRIDLIB_DEP)
	$(SHAREDLD) $(SHARED_LFLAGS) $(SONAME_LFLAG_DRMAA10) -o libdrmaa$(SHAREDEXT).1.0 $(DRMAALIB_10_OBJS) $(DRMAA_OBJS) $(JAPILIB_10) $(JAPI_ADD_OBJS) \
      $(SECLIB) $(WINGRIDLIB) $(LIBS) $(LIBRARY_LIBS) $(DLLIB) \
   && ../scripts/nonreentrant.sh -a `../dist/util/arch` -w libdrmaa$(SHAREDEXT).1.0 && true

# Needed to compile howtos, examples, and unit tests
libdrmaa$(SHAREDEXT): $(DRMAALIB_V)
	rm -f libdrmaa$(SHAREDEXT) ; cp libdrmaa$(SHAREDEXT).1.0 libdrmaa$(SHAREDEXT)
	../scripts/link_jnilib.sh libdrmaa  $(SHAREDEXT) $(JAVA_SHAREDEXT)

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(JAPILIB_DIR)/japi_dependencies

###############################################################################
# include examples from the howto
###############################################################################
include $(JAPILIB_DIR)/howto/Makefile

###############################################################################
# rules to build object codes
###############################################################################
drmaa.o: $(JAPILIB_DIR)/drmaa.c
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(JAPILIB_DIR)/drmaa.c -o drmaa.o

japi.o: $(JAPILIB_DIR)/japi.c 
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(JAPILIB_DIR)/japi.c -o japi.o

com_sun_grid_drmaa_SessionImpl.o: $(CLASSES_DIR)/com_sun_grid_drmaa_SessionImpl.c
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(CLASSES_DIR)/com_sun_grid_drmaa_SessionImpl.c -o com_sun_grid_drmaa_SessionImpl.o

#---------------------------------------------------------------------

test_drmaa: test_drmaa.1.0
	rm -f test_drmaa ; cp test_drmaa.1.0 test_drmaa

test_drmaa.1.0: test_drmaa.o $(DRMAALIB) $(WINGRIDLIB_DEP)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa.o libdrmaa$(SHAREDEXT).1.0 $(WINGRIDLIB) $(LIBS)

test_drmaa.o: $(JAPILIB_DIR)/test_drmaa.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa.c -o test_drmaa.o

test_drmaa_sync: test_drmaa_sync.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_sync.o -ldrmaa $(LIBS)

test_drmaa_sync.o: $(JAPILIB_DIR)/test_drmaa_sync.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_sync.c

test_drmaa_mcpu: test_drmaa_mcpu.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_mcpu.o -ldrmaa

test_drmaa_mcpu.o: $(JAPILIB_DIR)/test_drmaa_mcpu.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_mcpu.c

test_drmaa_perf: test_drmaa_perf.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_perf.o -ldrmaa $(LIBS)

test_drmaa_perf.o: $(JAPILIB_DIR)/test_drmaa_perf.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_perf.c

test_drmaa_no_bin: test_drmaa_no_bin.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_no_bin.o -ldrmaa $(LIBS)

test_drmaa_no_bin.o: $(JAPILIB_DIR)/test_drmaa_no_bin.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_no_bin.c

test_drmaa_issue1768: test_drmaa_issue1768.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_issue1768.o -ldrmaa $(LIBS)

test_drmaa_issue1768.o: $(JAPILIB_DIR)/test_drmaa_issue1768.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_issue1768.c

test_drmaa_issue1832: test_drmaa_issue1832.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_issue1832.o -ldrmaa $(LIBS)

test_drmaa_issue1832.o: $(JAPILIB_DIR)/test_drmaa_issue1832.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_issue1832.c

test_drmaa_issue1892: test_drmaa_issue1892.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o $@ $(LFLAGS) test_drmaa_issue1892.o -ldrmaa $(LIBS)

test_drmaa_issue1892.o: $(JAPILIB_DIR)/test_drmaa_issue1892.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/test_drmaa_issue1892.c

example: example.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o example $(LFLAGS) example.o -ldrmaa $(LIBS)

example.o: $(JAPILIB_DIR)/example.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/example.c

compile: compile.o $(DRMAALIB)
	$(LD_WRAPPER) $(CC) -o compile $(LFLAGS) compile.o -ldrmaa $(LIBS)

compile.o: $(JAPILIB_DIR)/compile.c
	$(CC) $(CFLAGS) -c $(JAPILIB_DIR)/compile.c

=== source/libs/sgeobj/Makefile ===
###############################################################################
# Variable definitions for targets to build
###############################################################################
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__

SHELL = /bin/sh

SGEOBJLIB_DIR = $(SDIR)/libs/sgeobj

SGEOBJLIB = libsgeobj$(LIBEXT)

SGEOBJDLIB = libsgeobjd$(LIBEXT)

SGEOBJDLIB_SRC = \
         sge_answer.c \
         sge_feature.c \
         sge_all_listsL.c

SGEOBJLIB_SRC = \
         config.c \
         cull_parse_util.c \
         parse.c \
         sge_attr.c \
         sge_binding.c \
         sge_calendar.c \
         sge_centry.c \
         sge_conf.c \
         sge_cqueue.c \
         sge_cqueue_verify.c \
         sge_ckpt.c \
         sge_cuser.c \
			sge_cull_xml.c \
         sge_event.c \
         sge_host.c \
         sge_hgroup.c \
         sge_href.c \
         sge_id.c \
         sge_ja_task.c \
         sge_job.c \
         sge_proc.c \
         sge_jsv.c \
         sge_jsv_script.c \
         sge_resource_quota.c \
         sge_load.c \
         sge_order.c \
         sge_mailrec.c \
         sge_manop.c \
         sge_mesobj.c \
         sge_object.c \
         sge_pack.c \
         sge_path_alias.c \
         sge_pe.c \
         sge_pe_task.c \
         sge_qinstance.c \
         sge_qinstance_state.c \
         sge_qinstance_type.c \
         sge_qref.c \
         sge_range.c \
         sge_report.c \
         sge_schedd_conf.c \
         sge_sharetree.c \
         sge_str.c \
         sge_subordinate.c \
         sge_sub_object.c \
         sge_suser.c \
         sge_usage.c \
         sge_ulong.c \
         sge_userprj.c \
         sge_userset.c \
         sge_utility.c \
         str2nm_converter.c \
         sge_var.c \
         sge_eval_expression.c \
         sge_advance_reservation.c \
         sge_ack.c

SGEOBJDLIB_OBJS = $(SGEOBJDLIB_SRC:.c=.o)

SGEOBJLIB_OBJS = $(SGEOBJLIB_SRC:.c=.o)

SGEOBJLIB_TEST_PROGS = \
              test_sge_object \
              test_sge_range \
              test_sge_schedd_conf \
              test_sge_utility \
              test_sge_resource_quota \
              test_eval_expression

SGEOBJLIB_TEST_PROGS_OBJS = \
              test_sge_object.o \
              test_sge_range.o \
              test_sge_schedd_conf.o \
              test_sge_utility.o \
              test_sge_resource_quota.o\
              test_eval_expression.o

###############################################################################
# global rules: all, clean, depend, messages
###############################################################################
sgeobjlib: $(SGEOBJLIB) $(SGEOBJDLIB) $(SGEOBJLIB_TEST_PROGS)

sgeobjlib_clean:
		$(RM) $(SGEOBJLIB_OBJS) $(SGEOBJDLIB_OBJS) libsgeobj.a libsgeobj$(SHAREDEXT) \
              libsgeobjd.a libsgeobjd$(SHAREDEXT) sge_sub_object.o sge_sub_object_cpp.o \
              sge_sub_object.c $(SGEOBJLIB_TEST_PROGS) $(SGEOBJLIB_TEST_PROGS_OBJS)

sgeobjlib_depend:
		$(DEPEND) -f$(SGEOBJLIB_DIR)/sgeobj_dependencies $(SGEOBJLIB_DIR)/*.c

sgeobjlib_messages:
	@echo Creating $@
	@for i in `ls $(SGEOBJLIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

###############################################################################
# rules to build library
###############################################################################
libsgeobj.a:	$(SGEOBJLIB_OBJS) version.o
	$(AR) $(ARFLAGS) libsgeobj.a $(SGEOBJLIB_OBJS) version.o
	$(RANLIB) libsgeobj.a

libsgeobj$(SHAREDEXT): $(SGEOBJLIB_OBJS) $(SGEOBJDLIB) $(COMMLIB) $(CULLLIB) $(UTILIB)  
	$(SHAREDLD) $(SHARED_LFLAGS) -o libsgeobj$(SHAREDEXT) $(SGEOBJLIB_OBJS) -lsgeobjd -lcomm -lcommlists -lcull -luti $(LIBS) -lc

libsgeobjd.a:	$(SGEOBJDLIB_OBJS) version.o
	$(AR) $(ARFLAGS) libsgeobjd.a $(SGEOBJDLIB_OBJS) version.o
	$(RANLIB) libsgeobjd.a

libsgeobjd$(SHAREDEXT): $(SGEOBJDLIB_OBJS) $(CULLLIB) $(UTILIB) 
	$(SHAREDLD) $(SHARED_LFLAGS) -o libsgeobjd$(SHAREDEXT) $(SGEOBJDLIB_OBJS) -lcull -luti $(LIBS) -lc

###############################################################################
# include dependencies for object files generated by sge_depend
###############################################################################
include $(SGEOBJLIB_DIR)/sgeobj_dependencies

###############################################################################
# rules to build object codes
###############################################################################
config.o: $(SGEOBJLIB_DIR)/config.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/config.c

cull_parse_util.o: $(SGEOBJLIB_DIR)/cull_parse_util.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/cull_parse_util.c

parse.o: $(SGEOBJLIB_DIR)/parse.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/parse.c

sge_attr.o: $(SGEOBJLIB_DIR)/sge_attr.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_attr.c

sge_binding.o: $(SGEOBJLIB_DIR)/sge_binding.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_binding.c

sge_calendar.o: $(SGEOBJLIB_DIR)/sge_calendar.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_calendar.c

sge_centry.o: $(SGEOBJLIB_DIR)/sge_centry.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_centry.c

sge_conf.o: $(SGEOBJLIB_DIR)/sge_conf.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_conf.c

sge_cqueue.o: $(SGEOBJLIB_DIR)/sge_cqueue.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_cqueue.c

sge_cqueue_verify.o: $(SGEOBJLIB_DIR)/sge_cqueue_verify.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_cqueue_verify.c

sge_cuser.o: $(SGEOBJLIB_DIR)/sge_cuser.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_cuser.c

sge_cull_xml.o: $(SGEOBJLIB_DIR)/sge_cull_xml.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_cull_xml.c

sge_ckpt.o: $(SGEOBJLIB_DIR)/sge_ckpt.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_ckpt.c

sge_event.o:	$(SGEOBJLIB_DIR)/sge_event.c
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_event.c

sge_host.o: $(SGEOBJLIB_DIR)/sge_host.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_host.c

sge_hgroup.o: $(SGEOBJLIB_DIR)/sge_hgroup.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_hgroup.c

sge_href.o: $(SGEOBJLIB_DIR)/sge_href.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_href.c

sge_id.o: $(SGEOBJLIB_DIR)/sge_id.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_id.c

sge_ja_task.o: $(SGEOBJLIB_DIR)/sge_ja_task.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_ja_task.c

sge_job.o: $(SGEOBJLIB_DIR)/sge_job.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_job.c

sge_proc.o: $(SGEOBJLIB_DIR)/sge_proc.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_proc.c

sge_jsv.o: $(SGEOBJLIB_DIR)/sge_jsv.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_jsv.c

sge_jsv_script.o: $(SGEOBJLIB_DIR)/sge_jsv_script.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_jsv_script.c

sge_load.o: $(SGEOBJLIB_DIR)/sge_load.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_load.c

sge_resource_quota.o: $(SGEOBJLIB_DIR)/sge_resource_quota.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_resource_quota.c

sge_mailrec.o: $(SGEOBJLIB_DIR)/sge_mailrec.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_mailrec.c

sge_manop.o: $(SGEOBJLIB_DIR)/sge_manop.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_manop.c

sge_mesobj.o: $(SGEOBJLIB_DIR)/sge_mesobj.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_mesobj.c

sge_object.o: $(SGEOBJLIB_DIR)/sge_object.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_object.c

sge_pack.o: $(SGEOBJLIB_DIR)/sge_pack.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_pack.c

sge_path_alias.o: $(SGEOBJLIB_DIR)/sge_path_alias.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_path_alias.c

sge_pe.o: $(SGEOBJLIB_DIR)/sge_pe.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_pe.c

sge_pe_task.o: $(SGEOBJLIB_DIR)/sge_pe_task.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_pe_task.c

sge_qinstance.o: $(SGEOBJLIB_DIR)/sge_qinstance.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_qinstance.c

sge_qinstance_state.o: $(SGEOBJLIB_DIR)/sge_qinstance_state.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_qinstance_state.c

sge_qinstance_type.o: $(SGEOBJLIB_DIR)/sge_qinstance_type.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_qinstance_type.c

sge_order.o: $(SGEOBJLIB_DIR)/sge_order.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_order.c

sge_qref.o: $(SGEOBJLIB_DIR)/sge_qref.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_qref.c

sge_range.o: $(SGEOBJLIB_DIR)/sge_range.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_range.c

sge_report.o: $(SGEOBJLIB_DIR)/sge_report.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_report.c

sge_schedd_conf.o: $(SGEOBJLIB_DIR)/sge_schedd_conf.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_schedd_conf.c

sge_sharetree.o: $(SGEOBJLIB_DIR)/sge_sharetree.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_sharetree.c

sge_str.o: $(SGEOBJLIB_DIR)/sge_str.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_str.c

sge_subordinate.o: $(SGEOBJLIB_DIR)/sge_subordinate.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_subordinate.c

# dummy rule to propagate dependencies for sge_sub_object.c
sge_sub_object_cpp.o: $(SGEOBJLIB_DIR)/sge_sub_object_cpp.c
		touch sge_sub_object_cpp.o

sge_sub_object.c: sge_sub_object_cpp.o $(SGEOBJLIB_DIR)/sge_sub_object_cpp.c ../scripts/gen_subtype_info.sh
		$(CC) $(CFLAGS) -E $(SGEOBJLIB_DIR)/sge_sub_object_cpp.c | grep __SUBTYPE_MAPPING__ | sort -u | ../scripts/gen_subtype_info.sh sge_sub_object.c

sge_sub_object.o: sge_sub_object.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c sge_sub_object.c

sge_suser.o: $(SGEOBJLIB_DIR)/sge_suser.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_suser.c

sge_ulong.o: $(SGEOBJLIB_DIR)/sge_ulong.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_ulong.c

sge_userprj.o: $(SGEOBJLIB_DIR)/sge_userprj.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_userprj.c

sge_userset.o: $(SGEOBJLIB_DIR)/sge_userset.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_userset.c

sge_usage.o: $(SGEOBJLIB_DIR)/sge_usage.c 
		$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(SGEOBJLIB_DIR)/sge_usage.c

sge_utility.o: $(SGEOBJLIB_DIR)/sge_utility.c

=== source/libs/uti2/Makefile ===
# Copyright Dave Love,  2011

# Copyright (C) 2011 Dave Love, University of Liverpool <d.love@liv.ac.uk>
#
# This file is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation; either version 3 of
# the License, or (at your option) any later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this file.  If not, a copy can be downloaded
# from http://www.gnu.org/licenses/lgpl.html.

UTI2LIB_DIR  = $(SDIR)/libs/uti2

UTI2LIB  = libuti2$(LIBEXT)

UTI2LIB_SRC = sge_execvlp.c sge_cgroup.c util.c
UTI2LIB_OBJS = $(UTI2LIB_SRC:.c=.o)

uti2lib: $(UTI2LIB)

uti2lib_clean: 
	$(RM) $(UTI2LIB_OBJS) $(UTI2LIB) libuti2$(SHAREDEXT)

uti2lib_depend:
	$(DEPEND) -f$(UTI2LIB_DIR)/uti2_dependencies $(UTI2LIB_DIR)/*.c

uti2lib_messages:
	@echo Creating $@
	@for i in `ls $(UTI2LIB_DIR)/*.c`; do \
	   $(CC) $(CFLAGS) -DEXTRACT_MESSAGES -E $$i | $(XGETTEXT) - ;\
	done

libuti2.a: $(UTI2LIB_OBJS)
	$(AR) $(ARFLAGS) $(UTI2LIB) $(UTI2LIB_OBJS)
	$(RANLIB) $(UTI2LIB)

libuti2$(SHAREDEXT):  $(UTI2LIB_OBJS)
	$(SHAREDLD) $(SHARED_LFLAGS) -o libuti2$(SHAREDEXT) $(UTI2LIB_OBJS) $(LOADAVGLIBS) $(LIBS) -lc

include $(UTI2LIB_DIR)/uti2_dependencies

sge_execvlp.o: $(UTI2LIB_DIR)/sge_execvlp.c
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(UTI2LIB_DIR)/sge_execvlp.c

util.o: $(UTI2LIB_DIR)/util.c
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(UTI2LIB_DIR)/util.c

sge_cgroup.o: $(UTI2LIB_DIR)/sge_cgroup.c
	$(CC) $(CFLAGS) $(SHARED_CFLAGS) -c $(UTI2LIB_DIR)/sge_cgroup.c

=== source/experimental/jqmon_corba/jqmon/Makefile ===
#___INFO__MARK_BEGIN__
##########################################################################
#
#  The Contents of this file are made available subject to the terms of
#  the Sun Industry Standards Source License Version 1.2
#
#  Sun Microsystems Inc., March, 2001
#
#
#  Sun Industry Standards Source License Version 1.2
#  =================================================
#  The contents of this file are subject to the Sun Industry Standards
#  Source License Version 1.2 (the "License"); You may not use this file
#  except in compliance with the License. You may obtain a copy of the
#  License at http://gridengine.sunsource.net/Gridengine_SISSL_license.html
#
#  Software provided under this License is provided on an "AS IS" basis,
#  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#  See the License for the specific provisions governing your rights and
#  obligations concerning the Software.
#
#  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#  Copyright: 2001 by Sun Microsystems, Inc.
#
#  All Rights Reserved.
#
##########################################################################
#___INFO__MARK_END__
.SUFFIXES:

# protect source files

.PRECIOUS: %.java

# set sge directories
C4_DIR = ../..
QMON_DIR = $(C4_DIR)/jqmon_corba
QMON_GUI_DIR = $(QMON_DIR)/jqmon

# set idl compiler and idl options
JDK_HM = $(JDKHOME)
JDK_CLS = $(JDK_HM)/lib/classes.zip

# set compiler and runtime files
JAVA = $(JDK_HM)/bin/java
JAVAC = $(JDK_HM)/bin/javac

# set compiler options
# JAVAC_FLAGS = -J-mx64M

# set orb libs
ORB_DIR = $(C4_DIR)/../JOB-3.1.2
ORB_LIB = $(ORB_DIR)/lib
ORB_OB = $(ORB_DIR)/ob/lib
ORB_NAME = $(ORB_DIR)/naming/lib
ORB_PROP = $(ORB_DIR)/property/lib
ORB_EVENT = $(ORB_DIR)/event/lib

# set swing lib
SWING = /vol2/jdk11/swing-1.1


#  set classpath
CLASSPATH = -classpath .:$(JDK_CLS):$(JDK_HM)/:$(QMON_DIR)/:$(ORB_LIB)/:$(ORB_OB)/:$(ORB_NAME)/:$(ORB_PROP)/:$(ORB_EVENT)/:$(SWING)/swingall.jar

# declare sources to be compiled
SRCS = $(wildcard $(QMON_GUI_DIR)/*/*.java) $(wildcard $(QMON_GUI_DIR)/*/*/*.java)

ALLTARGETS = classfiles

all:  $(ALLTARGETS)  


.PHONY: 

classfiles:  
		$(JAVAC) $(JAVAC_FLAGS) $(CLASSPATH) $(SRCS) 
      
jqmonclean :
	rm -f $(ALLTARGETS)

=== debian/changelog ===
sge (8.1.6) unstable; urgency=low

  * New version.

 -- Dave Love <d.love@liverpool.ac.uk>  Wed, 09 Oct 2013 19:32:13 +0100

sge (8.1.5) unstable; urgency=low

  * New version (fixes armhf recognition).

 -- Dave Love <d.love@liverpool.ac.uk>  Thu, 19 Sep 2013 21:56:45 +0100

sge (8.1.4) unstable; urgency=low

  * Fix packaging on wheezy.
  * Drop explicit ant dependency.
  * Add motif alternative build dependency.
  * Depend on procps.
  * Fix some lintian warnings

 -- Dave Love <d.love@liverpool.ac.uk>  Tue, 27 Aug 2013 13:06:21 +0100

sge (8.1.3) unstable; urgency=low

  * Initial packaging, installing into /opt/sge.

 -- Dave Love <d.love@liv.ac.uk>  Sun, 04 Nov 2012 21:29:23 +0000

=== debian/control ===
Source: sge
Priority: optional
Section: utils
Maintainer: Dave Love <sge-bugs@liv.ac.uk>
Build-Depends: debhelper (>= 7.0.50), tcsh | c-shell, libdb-dev, libssl-dev,
 libncurses5-dev, libpam0g-dev, libxt-dev, motif-dev | lesstif2-dev,
 libxmu-dev, default-jdk, ant-optional, junit, javacc,
 libhwloc-dev (>= 1.1), libpam0g-dev, man-db
# add quilt if we acquire patches
Standards-Version: 3.9.1
Homepage: http://arc.liv.ac.uk/SGE
Vcs-darcs: http://arc.liv.ac.uk/repos/darcs/sge/
Vcs-Browser: https://arc.liv.ac.uk/trac/SGE/browser/sge

Package: sge
Architecture: any
# procps for /bin/ps, called in some places
Depends: ${shlibs:Depends}, ${misc:Depends}, sge-common, procps
Suggests: openssh-client
Recommends: sge-doc
Replaces: gridengine-client, gridengine-qmon, gridengine-master, gridengine-exec,
 libdrmaa-dev, libdrmaa-java
Description: Grid Engine programs
 Grid Engine is software that facilitates "distributed resource
 management" (DRM).  Far more than just simple load-balancing tools or
 batch scheduling mechanisms, DRM software typically provides the
 following key features across large sets of distributed resources:
 .
   * Policy based allocation of distributed resources (CPU time,
     software licenses, etc.)
   * Batch queuing & scheduling
   * Support diverse server hardware, OS and architectures
   * Load balancing & remote job execution
   * Detailed job accounting statistics
   * Fine-grained user specifiable resources
   * Suspend/resume/migrate jobs
   * Tools for reporting Job/Host/Cluster status
   * Job Arrays
   * Integration & control of parallel jobs
 .
 This package contains the Grid Engine programs.

Package: sge-common
Architecture: all
Section: utils
Depends: ${misc:Depends}, adduser, bsd-mailx | mailx, tcsh | c-shell
Replaces: gridengine-common
Description: Distributed resource management - common files
 Grid Engine is software that facilitates "distributed resource
 management" (DRM).  Far more than just simple load-balancing tools or
 batch scheduling mechanisms, DRM software typically provides the
 following key features across large sets of distributed resources:
 .
   * Policy based allocation of distributed resources (CPU time,
     software licenses, etc.)
   * Batch queuing & scheduling
   * Support diverse server hardware, OS and architectures
   * Load balancing & remote job execution
   * Detailed job accounting statistics
   * Fine-grained user specifiable resources
   * Suspend/resume/migrate jobs
   * Tools for reporting Job/Host/Cluster status
   * Job Arrays
   * Integration & control of parallel jobs
 .
 This package contains required shared files and the basic configuration.

Package: sge-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Grid Engine documentation
 Grid Engine is software that facilitates "distributed resource
 management" (DRM).  Far more than just simple load-balancing tools or
 batch scheduling mechanisms, DRM software typically provides the
 following key features across large sets of distributed resources:
 .
   * Policy based allocation of distributed resources (CPU time,
     software licenses, etc.)
   * Batch queuing & scheduling
   * Support diverse server hardware, OS and architectures
   * Load balancing & remote job execution
   * Detailed job accounting statistics
   * Fine-grained user specifiable resources
   * Suspend/resume/migrate jobs
   * Tools for reporting Job/Host/Cluster status
   * Job Arrays
   * Integration & control of parallel jobs
 .
 This package contains the Grid Engine documentation.

Package: sge-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, sge (= ${binary:Version})
Description: Grid Engine programs
 Grid Engine is software that facilitates "distributed resource
 management" (DRM).  Far more than just simple load-balancing tools or
 batch scheduling mechanisms, DRM software typically provides the
 following key features across large sets of distributed resources:
 .
   * Policy based allocation of distributed resources (CPU time,
     software licenses, etc.)
   * Batch queuing & scheduling
   * Support diverse server hardware, OS and architectures
   * Load balancing & remote job execution
   * Detailed job accounting statistics
   * Fine-grained user specifiable resources
   * Suspend/resume/migrate jobs
   * Tools for reporting Job/Host/Cluster status
   * Job Arrays
   * Integration & control of parallel jobs
 .
 This package contains debugging versions of the Grid Engine programs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Copyright (C) 2012 Dave Love, The University of Liverpool
# Licence: GPL-3 or later

#export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
# for qmon, sigh
export DEB_BUILD_HARDENING_FORMAT=0

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
NOOPT=-no-opt
endif
ifneq (,$(DEB_PARALLEL_JOBS))
PARALLEL = -parallel $(DEB_PARALLEL_JOBS)
endif
SGE_ROOT=/opt/sge

%:
	dh $@

override_dh_auto_build: build-stamp
build-stamp:
	cd source && \
	sh scripts/bootstrap.sh && \
	SGE_INPUT_CFLAGS="$$CFLAGS $$CPPFLAGS" SGE_INPUT_LDFLAGS="$$LDFLAGS" \
	  ./aimk -no-remote -debug $(NOOPT) $(PARALLEL) && \
	./aimk -man && ant drmaa.javadoc juti.javadoc jgdi.javadoc jjsv.javadoc
	touch build-stamp

override_dh_auto_install:
	dh_installdirs
	mkdir -p debian/tmp$(SGE_ROOT)
	cd source && /usr/bin/yes | \
	SGE_ROOT=${CURDIR}/debian/tmp$(SGE_ROOT) \
	  scripts/distinst -local -allall -noexit $(source/dist/util/arch)
	cd debian/tmp/$(SGE_ROOT) && \
	rm -rf hadoop dtrace start_gui_installer doc/arc_depend* \
	  util/gui-installer util/sgeSMF && \
	rm -f util/resources/scripts/qsched-1.0/COPYING && \
	rm -f util/resources/scripts/README* && \
	rm -f util/resources/loadsensors/interix-loadsensor.sh
	find debian/tmp/$(SGE_ROOT)/man -type l | xargs rm
	mandb -u -c debian/tmp/$(SGE_ROOT)/man
# We need the versions of the db utils corresponding to the dev library.
# They are named like db5.1_load.
	db=$$(dpkg-query -W --showformat '$${Version}' libdb-dev) && \
	  db=$$(expr $$db : '\([1-9]\.[0-9]\)') && \
	  cd debian/tmp$(SGE_ROOT)/utilbin/lx* && \
	  ln -sf /usr/bin/db$${db}_load db_load && \
	  ln -sf /usr/bin/db$${db}_dump db_dump

override_dh_auto_clean:
	rm -f build-stamp
# aimk clean doesn't DTRT
	cd source && rm -rf CLASSES JAVADOCS MANSBUILD_* dist/qmon/Qmon
	find source -type d -name "LINUX*" -print0 | xargs --null rm -rf
	find source -type d -name "build" -print0 | xargs --null rm -rf
	find source -name "*_dependencies" -print0 | xargs --null rm -f

override_dh_strip:
	dh_strip --dbg-package=sge-dbg

override_dh_gencontrol:
# we need to depend on the db utils version corresponding to libdb-dev
	sed -i debian/sge.substvars -e 's/ lib\(db[^ ,]*\)/ &, \1-util/'
	dh_gencontrol
